  int blue = 6;                                                       //Der Ausgang für das Blau Signal ist 6 (vorher 11)
int green = 5;                                                     //Der Ausgang für das Grün Signal ist 5 (vorher 10) 
int red = 3;                                                           //Der Ausgang für das rot Signal ist 3 8vorher 9)

int automat = 10;
int tag = 7;
int segel = 9;
int gewitter = 11;
int nacht = 12;
int leuchtturm = 8;
int lichtinnen = 2;
int lichtaussen = 4;


int b = 30;                     //Länge eines Blitzes
int HWolk = 10;       //Helligkeit bei Gewitter (zwischen 0 und 255)
int paus = 1000;  //Pause zwischen Blitzen
int ZB = 1;      //Anzahl Blitze in einer Folge
int x = 0;        // Zufallszahl zw. 1 u. 4, damit es nur an jedem 4. Tag gewittert bzw. die Segler nicht fahren


int analogPin = A0;                 //Spannung an A0 (Poti) soll ausgelesen werden A0 ist die Variable analogPin    
long G = 1000;          //ausgelesener Potentiometerwert an A0. Zwischen 0 und 1023. Dient als Basis für die Pausen- und Verzögerungswerte
int z = 10;       //Für die  Verzögerungen. Je größer z, desto kürzer die Verzögerungen p. Der Wert von G (0 bis 1023) wird durch z geteilt, um p zu ermitteln. p = G / z. 
int p = 30;      // p ist die kurze Wartezeit für praktisch alles. Z.B. Geschwindigkeit beim Farbwechsel
int y = 100;       //Vervielfältiger für die langen Pausen. P ist G * y. Je größer y, desto länger der Tag
long P = 20000;     //P ist für lange Pausen. P = G * y
long T = 5000;                  //Restzeit nach Gewitter

int i = 0;           // Zähler

int anz = 5;          // Anzahl Blitzsequenzen
int j = 0;            // Zähler Blitzsequenzen
                                
                                                        //da der Wert größer als 32.767 ist, muss anstatt "int" "long" verwendet werden
int Hblue = 0;                                                     //Hblue steht für den blauen PWM Wert (0-255)
int Hgreen = 0;                                                     //Hgreen steht für den grünen PWM Wert (0-255)
int Hred = 0;                                                       //Hred steht für den roten PWM Wert (0-255)
 
void setup() {
  
  pinMode(blue, OUTPUT);                                  //blue (6) ist jetzt ein Ausgang - ob PWM oder digital muss nicht definiert werden
  pinMode(green, OUTPUT);                                //green (5) ist jetzt ein Ausgang
  pinMode(red, OUTPUT);                                 //red (3) ist jetzt ein Ausgang
  pinMode(automat, OUTPUT);                              //1 ist jetzt ein Ausgang. Hauptschalter für Automatik
  pinMode(tag, OUTPUT);                              //screen (7) ist jetzt ein Ausgang. Monitor und Video Tag an
  pinMode(segel, OUTPUT);                              //segel (9) ist jetzt ein Ausgang. Segler, Surfer an
  pinMode(gewitter, OUTPUT);                              //Gewitter (11) ist jetzt ein Ausgang. Video Gewitter
  pinMode(analogPin, INPUT);                                  //A0 wird als INPUT für Poti gesetzt
  pinMode(nacht, OUTPUT);                             // nacht (13) ist Ausgang. Video Nacht
  pinMode(leuchtturm, OUTPUT);                        // leuchtturm (15) ist Ausgang. Drehlampe Leuchtturm
  pinMode(lichtinnen, OUTPUT);                          // lichtinnen (2) ist Ausgang, Licht im Turm
  pinMode(lichtaussen, OUTPUT);                         // lichtaussen (4) ist Ausgang, Lichtstrahler außen am Turm
  
 //  randomSeed(analogRead(1));
  

Serial.begin(9600);                         // Setup der seriellen Verbindung
// digitalWrite(automat, LOW);                //Strom für Manualbetrieb abschalten
//digitalWrite(screen, LOW);                 // Bildschirm an mit Tagesvideo
// digitalWrite(lichtinnen, LOW);
// digitalWrite(lichtaussen, LOW);
// digitalWrite(segel, LOW);
// digitalWrite(gewitter, HIGH);
//digitalWrite(nacht, HIGH);
// digitalWrite(leuchtturm, HIGH);
}

void loop() {

digitalWrite(automat, LOW);
digitalWrite(tag, LOW);
digitalWrite(lichtinnen, LOW);
digitalWrite(lichtaussen, LOW);
digitalWrite(nacht, HIGH);
digitalWrite(gewitter, HIGH);
//  digitalWrite(segel, LOW);

x = random(4);      // x bekommt einen zufälligen ganzzahligen Wert zwischen 1 und 4

if (x == 1) {     // manchmal gehen die Segler zufällig nicht an

  digitalWrite(segel, HIGH);
}

else {
(segel, LOW);
}



 
 Serial.println("Tag beginnt"); 
G = analogRead(analogPin) + 40;                //schreibt den Wert von PIN A0 in Variable G
p = G / z;                         
P = G * y;
Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);

 delay(200 * p); 
  
  while (Hblue <= 40)                                          //eine "while"-Schleife beginnt -
                                                                             //Solange die Bedingung wahr ist, wird die folgende Geschweifte Klammer wiederholt
  {                                                         //In dieser Schleife wird von einem Nächtlichen blau/rot ein Sonnenaufgang blau/rot
    
    analogWrite(blue, Hblue);                                //der Wert von Hblue (aktuell 20) wird als PWM auf den Ausgang 11 geschrieben
    analogWrite(green, Hgreen);                           //der Wert von Hgreen (aktuell 0) wird als PWM auf den Ausgang 10 geschrieben
    analogWrite(red, Hred);                                   //der Wert von Hred (aktuell 20) wird als PWM auf den Ausgang 9 geschrieben
  
    delay(p);                                             //eine mittlere Pause
    
    Hblue ++;                                                        //Die Helligkeit von blau wird um 1 gesteigert.
  }


Hblue = 40;
Hgreen = 0;
Hred = 0;



while (Hred <= 100)                                          //eine "while"-Schleife beginnt -
                                                                             //Solange die Bedingung wahr ist, wird die folgende Geschweifte Klammer wiederholt
  {                                                                          //In dieser Schleife wird von einem Nächtlichen blau/rot ein Sonnenaufgang blau/rot
    analogWrite(blue, Hblue);                                //der Wert von Hblue (aktuell 20) wird als PWM auf den Ausgang 11 geschrieben
    analogWrite(green, Hgreen);                           //der Wert von Hgreen (aktuell 0) wird als PWM auf den Ausgang 10 geschrieben
    analogWrite(red, Hred);                                   //der Wert von Hred (aktuell 20) wird als PWM auf den Ausgang 9 geschrieben
    delay(p);                                             //eine kleine Pause
    Hred ++;                                             //Die Helligkeit von brot wird um 1 gesteigert
  }

digitalWrite(lichtaussen, HIGH);

delay(200 * p);

  while (Hred <= 255)                                          //eine "while"-Schleife beginnt -
                                                                             //Solange die Bedingung wahr ist, wird die folgende Geschweifte Klammer wiederholt
  {                                                                          //In dieser Schleife wird von einem Nächtlichen blau/rot ein Sonnenaufgang blau/rot
    analogWrite(blue, Hblue);                                //der Wert von Hblue (aktuell 20) wird als PWM auf den Ausgang 11 geschrieben
    analogWrite(green, Hgreen);                           //der Wert von Hgreen (aktuell 0) wird als PWM auf den Ausgang 10 geschrieben
    analogWrite(red, Hred);                                   //der Wert von Hred (aktuell 20) wird als PWM auf den Ausgang 9 geschrieben
    delay(p);                                                          //eine kleine Pause
    Hblue ++;                                                        //Die Helligkeit von blau wird um 1 gesteigert.
    Hred ++;                                    //Nicht nur blau muss heller werden, auch rot steig in jeder Runde der Schleife um 1

  }

digitalWrite(leuchtturm, HIGH);
  
G = analogRead(analogPin) +40;                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);           // Wert ausgeben

delay(300 * p);

digitalWrite(lichtinnen, HIGH);
 
  Hblue = 255;                                                     //
  Hgreen = 0;                                                      // Zwischenstand der Werte
  Hred = 255;                                                      //

delay(100 * p);

while (Hgreen <= 30)                                      //in dieser Schleife fahren wir das grün hoch - aus dem Morgenrot wird Tageslicht weiß
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(2 * p);
    Hgreen ++;
  }


// digitalWrite(segel, LOW);                                  // Segler und Surfer fangen an, sich zu bewegen

 
  while (Hgreen <= 255)                                      //in dieser Schleife fahren wir das grün hoch - aus dem Morgenrot wird Tageslicht weiß
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(2 * p);
    Hgreen ++;
  }
  
  Hblue = 255;                                                      //
  Hgreen = 255;                                                   // Zwischenstand der Werte
  Hred = 255;                                                       //

 delay(random(300 * p, 600 * p));


G = analogRead(analogPin) +40;                //schreibt den Wert von PIN A0 plus 20 (also 20 bis 1.043) in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);




// jetzt kommt die Gewittersequenz

x = random(4);      // x bekommt einen zufälligen ganzzahligen Wert zwischen 1 und 4

if (x == 1) {        // wenn x = 1 ist, soll die nachfolgende Gewittersequenz laufen, sonst nicht. Bei x = random(4): Chance 1 zu 4
                  
  T = random(P);    // T ist ein zufälliger Teil von P, der langen Tagespause
  delay(T);         // Das Gewitter soll zufällig nach delay(T) losgehen

  // digitalWrite(tag, HIGH);
  
  digitalWrite(gewitter, LOW);       //Videoplayer mit Video Schlechtwetter wird gestartet

anz = random(5, 9);

j = 0;

while (j < anz)
{
  
  HWolk = random(20, 80);    // HWolk ist die Helligkeit bei Gewitterwolken. Hier zufällig zwischen 10 und 80
  
                                                     
 while (Hgreen >= HWolk)        // in der folgenden Sequenz wird auf den zufälligen Wert HWolk abgedimmt                                  
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen --;
    Hred --;
    Hblue --;
  }

if (HWolk < 60)
{
  digitalWrite(lichtinnen, LOW);
}

ZB = random(5, 25);       // Es wird eine zufällige Anzahl von Blitzen zwischen 10 und 40 festgelegt

i = 0;

while (i < ZB)            // Wiederholungsschleife, bis zufällige Anzahl Blitze erreicht ist
{
 
 Hblue = 255;         // Blitz mit voller Helligkeit, Blitzdauer = delay(b)                                              
 Hgreen = 255;                                                   
 Hred = 255;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 b = random(10, 40);
 delay(b);
 
Hblue = HWolk;          // nach Blitz volle Dunkelheit (Dauer wieder b)                                             
 Hgreen = HWolk;                                                   
 Hred = HWolk;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 b = random(30, 70);
 delay(b);

i = i+1;          // Zähler Blitze wird raufgezählt
}

// digitalWrite(lichtaussen, LOW);

// digitalWrite(segel, HIGH);

delay(300 * p);

j = j + 1;

}

j = 0;

HWolk = random(60, 130);

Hblue = HWolk;                                                      
 Hgreen = HWolk;                                                   
 Hred = HWolk;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);

 // digitalWrite(lichtaussen, HIGH);
 
 digitalWrite(gewitter, HIGH);                  //Schlechtwettervideo aus
 
 // digitalWrite(tag, LOW);
 
 delay(random(300 * p));

while (Hgreen <= 255)               // langsam wird wieder alles bis auf volle Helligkeit erhöht (delay b)
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen ++;
    Hred ++;
    Hblue ++;
  }

digitalWrite(lichtinnen, HIGH);

  Hblue = 255;                                                      //
  Hgreen = 255;                                                   // Zwischenstand der Werte
  Hred = 255;    


// digitalWrite(segel, LOW);

// delay(P - T);       // 

}

// if (!(x == 1))

// delay(P);

G = analogRead(analogPin) +40;                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
 
delay(P * 2);  


  while (Hgreen >= 0)                                          //in deiser Schleife nehmen wir den grün Anteil heraus - Abendrot
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen --;                                                       //sowie ++ den Wert immer um 1 anhebt, senkt -- den Wert immer um 1
  }
  Hblue = 255;                                                      //
  Hgreen = 0;                                                       // Zwischenstand der Werte
  Hred = 255;                                                       //
  
  while (Hblue >= 2)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hblue --;
  }
  
digitalWrite(lichtinnen, LOW);
digitalWrite(nacht, LOW);
digitalWrite(tag, HIGH);


delay(100 * p);

while (Hred >= 30)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hred --;
  }

digitalWrite(leuchtturm, LOW);

while (Hred >= 0)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hred --;
  }

// digitalWrite(segel, HIGH);



G = analogRead(analogPin) +40;                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);

// while (Hblue >= 3)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
//  {
//    analogWrite(blue, Hblue);
//    analogWrite(green, Hgreen);
//    analogWrite(red, Hred);
//    delay(p);
//    Hblue --;
//    Hred --;
//    Hgreen --;
//  }

digitalWrite(lichtaussen, LOW);

delay(p * 300);

  
  Hblue = 2;                                                       //
  Hgreen = 0;                                                      // Zwischenstand der Werte
  Hred = 0; 
  analogWrite(blue, Hblue);
  analogWrite(green, Hgreen);
  analogWrite(red, Hred);

G = analogRead(analogPin) +40;                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;

 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
 
x = random(4);      // x bekommt einen zufälligen ganzzahligen Wert zwischen 1 und 4

if (x == 1) {     // manchmal gehen die Segler zufällig nicht an

  digitalWrite(segel, HIGH);
}

else {
(segel, LOW);
}



// jetzt kommt die Gewittersequenz in der Nacht

x = random(4);      // x bekommt einen zufälligen ganzzahligen Wert zwischen 1 und 4

if (x == 1) {        // wenn x = 1 ist, soll die nachfolgende Gewittersequenz laufen, sonst nicht. Bei x = random(4): Chance 1 zu 4
                  

T = random(P); 
  
  delay((T * 1,5));
  
  digitalWrite(gewitter, LOW);       //Videoplayer mit Video Schlechtwetter wird gestartet

 
  digitalWrite(lichtinnen, LOW);

anz = random(4, 9);

j = 0;

while (j < anz)
{

ZB = random(4, 25);       // Es wird eine zufällige Anzahl von Blitzen zwischen 1 und 40 festgelegt
i = 0;
while (i < ZB)            // Wiederholungsschleife, bis zufällige Anzahl Blitze erreicht ist
{
 
 Hblue = 255;         // Blitz mit voller Helligkeit, Blitzdauer = delay(b)                                              
 Hgreen = 255;                                                   
 Hred = 255;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 b = random(10, 40);
 delay(b);
 
Hblue = 0;          // nach Blitz volle Dunkelheit (Dauer wieder b)                                             
 Hgreen = 0;                                                   
 Hred = 0;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 b = random(30, 50);
 delay(b);

i = i+1;          // Zähler Blitze wird raufgezählt
}

 delay(random(400 * p)); 

j = j+1;
}
 
j = 0;
 

 digitalWrite(gewitter, HIGH);       //Schlechtwettervideo aus
  

G = (analogRead(analogPin)) + 40;                //schreibt den Wert von PIN A0 in Variable G
p = G / z;                         
P = G * y;
Serial.print(G);              // Wert ausgeben
Serial.print("; ");
Serial.print(P);
Serial.print("; ");
Serial.println(p);
 
 delay(((P - T) * 2));

}

if (x != 1)
delay((P * 2));
 
}   // und nun beginnt alles wieder von vorn.
